#include "Span.hpp"
#include <iostream>

int main()
{
    std::cout << "Test too many numbers 1: ";
    {
        Span span(0);
        try
        {
            span.addNumber(1);
            std::cout << "failed !" << std::endl;
        }
        catch(const std::exception& e)
        {
            std::cout << "ok" << std::endl;
        }
    }
    std::cout << "Test too many numbers 2: ";
    {
        Span span(3);
        span.addNumber(1);
        span.addNumber(2);
        span.addNumber(3);
        try
        {
            span.addNumber(4);
            std::cout << "failed !" << std::endl;
        }
        catch(const std::exception& e)
        {
            std::cout << "ok" << std::endl;
        }
    }
    std::cout << "Test shortest empty span: ";
    {
        Span span(0);
        try
        {
            span.shortestSpan();
            std::cout << "failed !" << std::endl;
        }
        catch(const std::exception& e)
        {
            std::cout << "ok" << std::endl;
        }
    }
    std::cout << "Test shortest: ";
    {
        Span span(10);
        span.addNumber(0);
        span.addNumber(1);
        span.addNumber(2);
        span.addNumber(3);
        span.addNumber(4);
        if (span.shortestSpan() == 1)
            std::cout << "ok" << std::endl;
        else
            std::cout << "failed !" << std::endl;
    }
    std::cout << "Test longest empty span: ";
    {
        Span span(0);
        try
        {
            span.longestSpan();
            std::cout << "failed !" << std::endl;
        }
        catch(const std::exception& e)
        {
            std::cout << "ok" << std::endl;
        }
    }
    std::cout << "Test longest: ";
    {
        Span span(10);
        span.addNumber(0);
        span.addNumber(1);
        span.addNumber(2);
        span.addNumber(3);
        span.addNumber(4);
        if (span.longestSpan() == 4)
            std::cout << "ok" << std::endl;
        else
            std::cout << "failed !" << std::endl;
    }
    std::cout << "Test subject" << std::endl;
    {
        Span sp = Span(5);
        sp.addNumber(6);
        sp.addNumber(3);
        sp.addNumber(17);
        sp.addNumber(9);
        sp.addNumber(11);
        std::cout << sp.shortestSpan() << std::endl;
        std::cout << sp.longestSpan() << std::endl;
    }
}